<template>
  <form @submit.prevent>
    formulaire d'édition de From
    <br />
    <template v-for="field in fields" :key="field.name">
      {{ field.label }} :
      <input v-model="myAddress[field.name]" v-bind="field" />
      <br />
    </template>

    <button @click="$emit('update:model-value', myAddress)">Sauvegarder</button>
  </form>
</template>

<script>
export default {
  props: {
    modelValue: {
      type: Object,
      required: true,
    },
  },
  emits: ["update:model-value"],
  data() {
    return {
      fields: [
        {
          name: "road",
          label: "Road",
          title: "Road",
          type: "text",
          style: {
            color: "red",
          },
        },
        {
          name: "zipCode",
          label: "Zip Code",
          title: "Zip Code",
          type: "number",
          style: {
            backgroundColor: "green",
          },
        },
        {
          name: "city",
          label: "City",
          title: "City",
          type: "text",
        },
        {
          name: "complement",
          label: "Complement",
          title: "Complement",
          type: "text",
        },
        {
          name: "country",
          label: "Country",
          title: "Country",
          type: "text",
        },
        {
          name: "state",
          label: "State",
          title: "State",
          type: "text",
        },
      ],
      myAddress: null,
    };
  },
  watch: {
    modelValue: {
      handler(newValue, oldValue) {
        console.log("coucou", newValue.city, oldValue?.city);
        this.myAddress = {
          ...newValue,
        };
        console.log(this.myAddress, newValue, this.myAddress === newValue);
      },
      immediate: true,
    },
  },
};
</script>
